package com.gic.haoban.manage.service.service.out.impl;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.clerk.api.service.PowerService;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.GlobalInfo;
import com.gic.commons.util.GlobalVar;
import com.gic.commons.util.ImageUtil;
import com.gic.enterprise.api.dto.EnterpriseSettingDTO;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.dto.StoreGroupDTO;
import com.gic.enterprise.api.dto.StoreWidgetDTO;
import com.gic.enterprise.api.service.EnterpriseService;
import com.gic.enterprise.api.service.StoreGroupService;
import com.gic.enterprise.api.service.StoreWidgetService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.common.utils.RolesListUtils;
import com.gic.haoban.common.utils.UuidUtil;
import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.api.dto.SecretSettingDTO;
import com.gic.haoban.manage.api.dto.StaffClerkRelationDTO;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.dto.StaffDepartmentRelatedDTO;
import com.gic.haoban.manage.api.dto.StaffPrivacyUseLogDTO;
import com.gic.haoban.manage.api.dto.StaffQrCodeDTO;
import com.gic.haoban.manage.api.dto.UserLoginLogDTO;
import com.gic.haoban.manage.api.dto.WxEnterpriseDTO;
import com.gic.haoban.manage.api.dto.WxEnterpriseQwDTO;
import com.gic.haoban.manage.api.dto.role.StoreRoleDTO;
import com.gic.haoban.manage.api.enums.SecretTypeEnum;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.service.config.Config;
import com.gic.haoban.manage.service.dao.mapper.StaffDepartmentRelatedMapper;
import com.gic.haoban.manage.service.dao.mapper.StaffMapper;
import com.gic.haoban.manage.service.entity.TabHaobanDepartment;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.entity.TabHaobanStaffDepartmentRelated;
import com.gic.haoban.manage.service.entity.TabHaobanSyncErrorLog;
import com.gic.haoban.manage.service.service.DepartmentService;
import com.gic.haoban.manage.service.service.SecretSettingService;
import com.gic.haoban.manage.service.service.StaffClerkRelationService;
import com.gic.haoban.manage.service.service.StaffDepartmentRelatedService;
import com.gic.haoban.manage.service.service.StaffPrivacyUseLogService;
import com.gic.haoban.manage.service.service.StaffService;
import com.gic.haoban.manage.service.service.StoreRangeService;
import com.gic.haoban.manage.service.service.SyncErrorLogService;
import com.gic.haoban.manage.service.service.UserLoginLogService;
import com.gic.haoban.manage.service.service.WxEnterpriseService;
import com.gic.haoban.manage.service.util.EmojiFilterUtil;
import com.gic.redis.data.util.RedisUtil;
import com.gic.thirdparty.api.dto.PicUploadResDTO;
import com.gic.thirdparty.api.service.QQCloudPicService;
import com.gic.wechat.api.dto.qywx.QywxNewUseridDTO;
import com.gic.wechat.api.dto.qywx.UserDTO;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import cn.hutool.core.collection.CollectionUtil;

@Service
public class StaffApiServiceImpl implements StaffApiService {

    private static final Logger logger = LoggerFactory.getLogger(StaffApiServiceImpl.class);
    @Autowired
    private StaffService staffService;
    @Autowired
    private StaffMapper staffMapper;
    @Autowired
    private StaffDepartmentRelatedService staffDepartmentRelatedService;
    @Autowired
    private StaffDepartmentRelatedMapper staffDepartmentRelatedMapper;
    @Autowired
    private QywxUserApiService qywxUserApiService;
    @Autowired
    private WxEnterpriseService wxEnterpriseService;
    @Autowired
    private DepartmentService departmentService;
    @Autowired
    private ClerkService clerkService;
    @Autowired
    private StoreGroupService storeGroupService;
    @Autowired
    private UserLoginLogService userLoginLogService;
    @Autowired
    private SyncErrorLogService syncErrorLogService;
    @Autowired
    private QQCloudPicService qqCloudPicService;
    @Autowired
    private StaffClerkRelationService staffClerkRelationService;
    @Autowired
    private SecretSettingService secretSettingService;
    @Autowired
    private StaffPrivacyUseLogService staffPrivacyUseLogService;
    @Autowired
    private StoreWidgetService storeWidgetService;
    @Autowired
    private PowerService powerService;
    @Autowired
    private StoreRangeService storeRangeService;
    @Autowired
    private EnterpriseService enterpriseService;
    @Autowired
    private Config config;

    @Override
    public StaffDTO selectById(String staffId) {
        TabHaobanStaff staff = staffService.selectById(staffId);
        return EntityUtil.changeEntityByJSON(StaffDTO.class, staff);
    }

    @Override
    public List<StaffDTO> listByPhoneNumber(String phoneNumber) {
        List<TabHaobanStaff> staffs = staffMapper.listByPhoneNumber(phoneNumber);
        return EntityUtil.changeEntityListByJSON(StaffDTO.class, staffs);
    }

    @Override
    public StaffDTO selectByNationcodeAndPhoneNumber(String wxEnterpriseId, String nationcode, String phoneNumber) {
        TabHaobanStaff staff = staffService.selectByNationcodeAndPhoneNumber(wxEnterpriseId, nationcode, phoneNumber);
        return EntityUtil.changeEntityByJSON(StaffDTO.class, staff);
    }

    @Override
    public List<StaffDepartmentRelatedDTO> listStaffDepartmentByStaffId(String staffId) {
        List<TabHaobanStaffDepartmentRelated> list = staffDepartmentRelatedService.listStaffDepartmentByStaffId(staffId);
        // 如果成员部门为空,修复部门数据
        if(CollectionUtils.isEmpty(list)) {
           this.staffDepartmentRelatedService.repairStaffDepart(staffId);
        }
        return EntityUtil.changeEntityListByJSON(StaffDepartmentRelatedDTO.class, list);
    }

    @Override
    public Page<StaffDTO> pageStaff(List<String> departmentIds, Integer activeFlag, String keyword, BasePageInfo pageInfo, Integer relationFlag, String wxEnterpriseId) {
        List<String> staffIds = new ArrayList<>();
        if (relationFlag != null) {
            staffIds = staffClerkRelationService.listByWxEnterpriseId(wxEnterpriseId);
        }
        PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
        Page<StaffDTO> page = PageUtil.changePageHelperToCurrentPage(staffService.pageStaff(staffIds, activeFlag, keyword, departmentIds, wxEnterpriseId, relationFlag), StaffDTO.class);
        List<StaffDTO> staffDTOList = page.getResult();
        if (CollectionUtils.isEmpty(staffDTOList)) {
            return new Page<>();
        }
        Set<String> staffIdList = staffDTOList.stream().map(dto -> dto.getStaffId()).collect(Collectors.toSet());
        List<String> relationIdList = this.staffClerkRelationService.listRelationsStaffId(staffIdList);
        staffDTOList.forEach(one -> {
            one.setRelationFlag(relationIdList.contains(one.getStaffId()) ? 1 : 0);
        });
        return page;
    }

    @Override
    public List<StaffDTO> listByIds(List<String> staffIds) {
        if (CollectionUtil.isEmpty(staffIds)) {
            return new ArrayList<StaffDTO>();
        }
        List<TabHaobanStaff> staffs = staffMapper.listByIds(staffIds);
        if (CollectionUtil.isNotEmpty(staffs)) {
            List<StaffDTO> resultList = EntityUtil.changeEntityListByJSON(StaffDTO.class, staffs);
            return resultList;
        } else {
            return new ArrayList<StaffDTO>();
        }
    }

    @Override
    public ServiceResponse getWxSaveNew(String wxUserId, String wxEnterpriseId) {
        ServiceResponse res = new ServiceResponse();
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (null == qwDTO) {
            logger.info("企业不存在:{}:{}", wxEnterpriseId, wxUserId);
            res.setMessage("企业不存在");
            res.setCode(2);
            return res;
        }
        String dkCorpid = qwDTO.getDkCorpid();
        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(qwDTO.getWxEnterpriseId(), SecretTypeEnum.CUSTOMIZED_APP.getVal());
        if (null == secretSetting || secretSetting.getCheckFlag() == 0) {
            logger.info("没有配置secret：{}", JSONObject.toJSONString(qwDTO));
            res.setMessage("没有配置secret");
            res.setCode(4);
            return res;
        }
        UserDTO user = null;
        if (qwDTO.getWxSecurityType() == 4) {
            user = qywxUserApiService.getWorkWxUser(qwDTO.getThirdCorpid(), config.getWxSuiteid(), wxUserId);
            logger.info("成员详情(第三方)={}", JSON.toJSONString(user));
            UserDTO userSelf = qywxUserApiService.getSelfWorkWxUser(dkCorpid, secretSetting.getSecretVal(), user.getOpen_userid());
            logger.info("成员详情(代开)={}", JSON.toJSONString(user));
            if (user != null && userSelf != null) {
                user.setName(userSelf.getName());
                user.setPosition(userSelf.getPosition());
            }
        } else {
            user = qywxUserApiService.getSelfWorkWxUser(dkCorpid, secretSetting.getSecretVal(), wxUserId);
            logger.info("成员详情(代开)={}", JSON.toJSONString(user));
        }
        if (null == user) {
            logger.info("企业微信用户不存在:{}:{}", wxEnterpriseId, wxUserId);
            res.setMessage("企业微信用户不存在");
            res.setCode(3);
            return res;
        }
        String nationCode = null;
        String phoneNumber = null;
        String imageUrl = changeHeaderImageUrl(user.getAvatar());
        String mobile = user.getMobile();
        if (StringUtils.isNotBlank(mobile)) {
            String[] arr = getNationCodeAndPhoneNumber(mobile);
            nationCode = arr[0];
            phoneNumber = arr[1];
        }
        String openUserid = getOpenUserid(wxUserId, dkCorpid, qwDTO);
        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(wxUserId, openUserid, wxEnterpriseId);
        if (staff != null) {
            staffService.delOtherStaffByWxUserId(staff.getWxUserId(), staff.getStaffId(), wxEnterpriseId);
        }
        staff = (staff == null ? new TabHaobanStaff() : staff);
        staff.setWxUserId(wxUserId);
        if (StringUtils.isNotBlank(openUserid)) {
            staff.setWxOpenUseId(openUserid);
        }
        staff.setUpdateTime(new Date());
        staff.setStatusFlag(1);
        staff.setWxEnterpriseId(wxEnterpriseId);
        if (StringUtils.isNotBlank(user.getAvatar())) {
            staff.setHeadImg(imageUrl);
        }
        if (StringUtils.isNotBlank(user.getName())) {
            user.setName(EmojiFilterUtil.removeAllEmoji(user.getName()));
            staff.setStaffName((user.getName()));
        }
        if (StringUtils.isNotBlank(user.getAlias())) {
            user.setAlias(EmojiFilterUtil.removeAllEmoji(user.getAlias()));
            staff.setNickName((user.getAlias()));
        }
        staff.setPhoneNumber(phoneNumber);
        staff.setNationCode(nationCode);
        staff.setSex(user.getGender() == null ? 1 : Integer.parseInt(user.getGender()));
        staff.setPostion(user.getPosition());
        staff.setExtendPostion(user.getExternal_position());
        String qr_code = user.getQr_code();
        if (StringUtils.isNotBlank(qr_code)) {
            staff.setQrCode(qr_code);
        }
        //成员更改或更新
        if (StringUtils.isBlank(staff.getStaffId())) {
            logger.info("新增成员");
            staff.setActiveFlag(0);
            staff.setCreateTime(new Date());
            staffService.add(staff);
        } else {
            staffService.updateByPrimaryKey(staff);
        }
        logger.info("staff变更保存：{}", JSONObject.toJSONString(user));
        this.staffDepartmentRelatedService.staffDepartChange(staff, wxEnterpriseId, user.getDepartment(),true);
        // 返回结果带上员工姓名
        res.setResult(staff.getStaffName());
        return res;
    }

    /**
     * 获取wxopenuserid
     *
     * @param userId
     * @param corpid
     * @return
     */
    private String getOpenUserid(String userId, String corpid, WxEnterpriseQwDTO qwDTO) {
        if (qwDTO.getWxSecurityType() == 2) {
            return userId;
        }
        List<QywxNewUseridDTO> list = null;
        if (qwDTO.getWxSecurityType() == 4) {
            list = qywxUserApiService.useridToOpenuserid(qwDTO.getThirdCorpid(), config.getWxSuiteid(), Collections.singletonList(userId));
        } else {
            // 绝色这类商户在2个服务商,在2023516要切换调
            Object o = RedisUtil.getCache("bgrjswxEnterpriseId");
            if (null != o && o.toString().contains(qwDTO.getWxEnterpriseId())) {
                logger.info("绝色同步通讯录");
                list = qywxUserApiService.useridToOpenuserid(qwDTO.getThirdCorpid(), config.getWxSuiteid(), Collections.singletonList(userId));
            } else {
                SecretSettingDTO set = this.secretSettingService.getSecretSetting(qwDTO.getWxEnterpriseId(), SecretTypeEnum.CUSTOMIZED_APP.getVal());
                list = qywxUserApiService.getSelfUseridToOpenuserid(qwDTO.getDkCorpid(), set.getSecretVal(), Collections.singletonList(userId));
            }
        }
        logger.info("明文userId转密文={},{}", userId, JSON.toJSONString(list));
        if (CollectionUtils.isEmpty(list)) {
            return "";
        }
        return list.get(0).getOpen_userid();
    }

    private String[] getNationCodeAndPhoneNumber(String phoneNumber) {
        String[] arr = new String[2];
        if (StringUtils.isBlank(phoneNumber)) {
            arr[0] = "";
            arr[1] = "";
            return arr;
        }
        arr[0] = "86";
        arr[1] = phoneNumber;
        if (phoneNumber.startsWith("+853")) {
            arr[0] = "853";
            arr[1] = phoneNumber.replace("+853", "");
        }
        if (phoneNumber.startsWith("+852")) {
            arr[0] = "852";
            arr[1] = phoneNumber.replace("+852", "");
        }
        if (phoneNumber.startsWith("+886")) {
            arr[0] = "886";
            arr[1] = phoneNumber.replace("+886", "");
        }
        if (phoneNumber.startsWith("+65")) {
            arr[0] = "65";
            arr[1] = phoneNumber.replace("+65", "");
        }
        if (phoneNumber.startsWith("+66")) {
            arr[0] = "66";
            arr[1] = phoneNumber.replace("+66", "");
        }
        return arr;
    }

    @Override
    public ServiceResponse wxGetAdd(String userId, String wxEnterpriseId) {
        RedisUtil.lock("haoban_add_user" + wxEnterpriseId + userId, 2L);
        ServiceResponse wxSaveNew = getWxSaveNew(userId, wxEnterpriseId);
        logger.info("信息:{}", JSONObject.toJSONString(wxSaveNew));
        return wxSaveNew;
    }

    @Override
    public void wxFristAdd(String userJson, String wxEnterpriseId) {
        if (StringUtils.isBlank(userJson)) {
            return;
        }
        UserDTO user = JSON.parseObject(userJson, UserDTO.class);
        //获取微信用户信息
        String userId = user.getUserid();
        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId, wxEnterpriseId);
        if (staff == null) {
            WxEnterpriseDTO enterpriseDTO = wxEnterpriseService.selectById(wxEnterpriseId);
            if (enterpriseDTO != null) {
                Date now = new Date();
                logger.info("【新增用户】user={}", JSON.toJSONString(user));
                TabHaobanStaff tab = new TabHaobanStaff();
                tab.setWxUserId(userId);
                tab.setCreateTime(now);
                tab.setUpdateTime(now);
                tab.setStatusFlag(1);
                tab.setWxEnterpriseId(wxEnterpriseId);
                if (StringUtils.isNotBlank(user.getAvatar())) {
                    tab.setHeadImg(changeHeaderImageUrl(user.getAvatar()));
                }
                tab.setPhoneNumber(user.getMobile());
                if (StringUtils.isNotBlank(user.getName())) {
                    user.setName(EmojiFilterUtil.removeAllEmoji(user.getName()));
                    tab.setStaffName((user.getName()));
                }
                if (StringUtils.isNotBlank(user.getAlias())) {
                    user.setAlias(EmojiFilterUtil.removeAllEmoji(user.getAlias()));
                    tab.setNickName((user.getAlias()));
                }
                if (StringUtils.isNotBlank(tab.getPhoneNumber())) {
                    tab.setNationCode("86");
                }
                tab.setSex(user.getGender() == null ? 1 : Integer.parseInt(user.getGender()));
                tab.setActiveFlag(1);
                tab.setPostion(user.getPosition());
                tab.setExtendPostion(user.getExternal_position());
                if (user.getStatus() != null && user.getStatus() == 1) {
                    tab.setActiveFlag(1);
                } else {
                    tab.setActiveFlag(0);
                }
                staffService.add(tab);
            }
        } else {
            WxEnterpriseDTO enterpriseDTO = wxEnterpriseService.selectById(wxEnterpriseId);
            if (enterpriseDTO != null) {
                logger.info("【修改用户】user={}", JSON.toJSONString(user));
                Integer[] departmentId = user.getDepartment();
                String departmentIds = "";
                for (Integer integer : departmentId) {
                    TabHaobanDepartment tabDepartment = departmentService.getByWxId(integer.toString(), wxEnterpriseId);
                    if (tabDepartment != null) {
                        departmentIds += tabDepartment.getDepartmentId() + ",";
                    }
                }
                if (StringUtils.isNotBlank(departmentIds)) {
                    departmentIds = departmentIds.substring(0, departmentIds.length() - 1);
                }
                StaffDTO staffDTO = EntityUtil.changeEntityByJSON(StaffDTO.class, staff);
                staffDTO.setWeixinPush(true);
                this.staffEdit(staffDTO, departmentIds);
            }
        }
    }

    private void staffEditDeal(StaffDTO staffDTO, String departmentIds) {
        String staffId = staffDTO.getStaffId();
        TabHaobanStaff oldStaff = staffService.selectById(staffId);
        logger.info("【员工修改】oldStaff={}", JSON.toJSONString(oldStaff));
        //1、先更新staff
        logger.info("【员工修改】staffDTO={}", JSON.toJSONString(staffDTO));
        staffService.updateByPrimaryKey(EntityUtil.changeEntityByJSON(TabHaobanStaff.class, staffDTO));
        //再去查一下
        TabHaobanStaff staff = staffService.selectById(staffId);
        String staffName = staff.getStaffName();
        List<TabHaobanStaffDepartmentRelated> list = staffDepartmentRelatedService.listStaffDepartmentByStaffId(staffId);
        Map<String, TabHaobanStaffDepartmentRelated> map = com.gic.commons.util.CollectionUtil.toMap(list, "departmentId");
        //2、该员工新增部门
        if (StringUtils.isNotBlank(departmentIds)) {
            String[] addIds = departmentIds.split(",");
            for (String addId : addIds) {
                if (!map.containsKey(addId)) {
                    //该员工新增了部门
                    StaffDepartmentRelatedDTO related = new StaffDepartmentRelatedDTO();
                    related.setStaffDepartmentRelatedId(UuidUtil.randomUUID());
                    related.setStaffId(staffId);
                    related.setClerkCode(null);
                    related.setDepartmentId(addId);
                    related.setNationCode(staff.getNationCode());
                    related.setPhoneNumber(staff.getPhoneNumber());
                    related.setStatusFlag(1);
                    related.setWxEnterpriseId(staff.getWxEnterpriseId());
                    related.setStaffName(staffName);
                    staffDepartmentRelatedService.add(related);
                } else {
                    //该员工部门没做改变(只更新手机号即可)
                    TabHaobanStaffDepartmentRelated related = map.get(addId);
                    if (StringUtils.isNotBlank(related.getPhoneNumber())) {
                        if (!related.getPhoneNumber().equals(staff.getPhoneNumber())) {
                            related.setPhoneNumber(staff.getPhoneNumber());
                            related.setNationCode(staff.getNationCode());
                            related.setUpdateTime(new Date());
                            related.setStaffName(staffName);
                            related.setWxEnterpriseId(staff.getWxEnterpriseId());
                            staffDepartmentRelatedMapper.updateByPrimaryKeySelective(related);
                        }
                    }
                }
            }
        }
        //3、该员工删除部门
        for (TabHaobanStaffDepartmentRelated staffDepartmentRelated : list) {
            if (departmentIds == null) {
                departmentIds = "";
            }
            //不包含，则说明员工删除了该部门
            if (!departmentIds.contains(staffDepartmentRelated.getDepartmentId())) {
                logger.info("【员工修改删除】tab1.getDepartmentId()={}", staffDepartmentRelated.getDepartmentId());
                StaffDepartmentRelatedDTO related = EntityUtil.changeEntityByJSON(StaffDepartmentRelatedDTO.class, staffDepartmentRelated);
                staffDepartmentRelatedService.del(related);
            }
        }
    }

    @Override
    public void staffEdit(StaffDTO staffDTO, String departmentIds) {
        this.staffEditDeal(staffDTO, departmentIds);
    }


    @Override
    public StaffDTO selectByUserIdAndEnterpriseId(String userId, String wxEnterpriseId) {
        return EntityUtil.changeEntityByJSON(StaffDTO.class, staffService.selectByUserIdAndEnterpriseId(userId, wxEnterpriseId));
    }

    @Override
    public StaffDTO getByUserIdAndReflushWhenNoPhone(String userId, String wxEnterpriseId) {
        StaffDTO staffDTO = EntityUtil.changeEntityByJSON(StaffDTO.class, staffService.selectByUserIdAndEnterpriseId(userId, wxEnterpriseId));
        return staffDTO;
    }

    @Override
    public StaffDepartmentRelatedDTO getDepartmentIdAndStaffId(String departmentId, String staffId) {
        TabHaobanStaffDepartmentRelated tab = staffDepartmentRelatedService.getDepartmentIdAndStaffId(departmentId, staffId);
        return EntityUtil.changeEntityByJSON(StaffDepartmentRelatedDTO.class, tab);
    }

    @Override
    public StaffDepartmentRelatedDTO getDepartmentIdAndCode(String departmentId, String code) {
        return EntityUtil.changeEntityByJSON(StaffDepartmentRelatedDTO.class, staffDepartmentRelatedMapper.getDepartmentIdAndCode(departmentId, code));
    }

    @Override
    public void initWxUser(String corpid, String contactSecret, String wxEnterpriseId, Integer wxDepartmentId, String taskId) {
        List<UserDTO> list = this.qywxUserApiService.listSelfDepartmentUser(corpid, contactSecret, wxDepartmentId.toString(), 0);
        if (CollectionUtils.isNotEmpty(list)) {
            for (UserDTO dto : list) {
                try {
                    this.wxGetAdd(dto.getUserid(), wxEnterpriseId);
                } catch (Exception e) {
                    TabHaobanSyncErrorLog tab = new TabHaobanSyncErrorLog();
                    tab.setDataId(dto.getUserid());
                    tab.setDataType(0);
                    tab.setLogType(0);
                    tab.setReason(e.getMessage());
                    tab.setTaskId(taskId);
                    tab.setWxEnterpriseId(wxEnterpriseId);
                    syncErrorLogService.add(tab);
                }
            }
        }
    }

    @Override
    public List<String> listUnBindClerk(String storeId) {
        if (StringUtils.isBlank(storeId)) {
            logger.error("门店id为空");
            return Collections.emptyList();
        }
        List<String> storeIds = new ArrayList<String>();
        storeIds.add(storeId);
        List<String> clerkList = clerkService.getclerkListByStoreIds(storeIds);
        List<StaffClerkRelationDTO> staffRelationList = staffClerkRelationService.listByClerkIds(clerkList);
        if (CollectionUtils.isEmpty(staffRelationList)) {
            logger.error("无未绑定导购");
            return Collections.emptyList();
        }
        List<String> clerkIds = staffRelationList.stream().filter(s -> s.getClerkId() != null).map(s -> s.getClerkId()).collect(Collectors.toList());
        if (CollectionUtils.isEmpty(clerkIds)) {
            logger.info("无未绑定导购id");
            return Collections.emptyList();
        }
        List<String> unBindList = clerkList.stream().filter(clerkId -> !clerkIds.contains(clerkId)).collect(Collectors.toList());
        logger.info("未绑定导购id：{}", JSON.toJSONString(unBindList));
        return unBindList;
    }

    @Override
    public String insertUserLoginLog(UserLoginLogDTO userLoginLogDTO) {
        return userLoginLogService.insertUserLoginLog(userLoginLogDTO);

    }

    @Override
    public int countByDepartmentIds(List<String> departmentIds) {
        if (departmentIds == null || departmentIds.isEmpty()) {
            return 0;
        }
        return staffDepartmentRelatedMapper.countByDepartmentIds(departmentIds);
    }

    private String changeHeaderImageUrl(String headImgUrl) {
        try {
            logger.info("图片headImgUrl：{}", headImgUrl);
            if (StringUtils.isBlank(headImgUrl)) {
                return headImgUrl;
            }
            byte[] data = ImageUtil.getImgbyte(headImgUrl);
            PicUploadResDTO uploadPic = qqCloudPicService.uploadPic(GlobalVar.ctxPropertiesMap.get(GlobalInfo.QQPIC_KEY_ENTERPRISE), data);
            logger.info("腾讯云万象优图返回" + JSON.toJSONString(uploadPic));
            return uploadPic.downloadUrl;
        } catch (Exception e) {
            logger.info("上传腾讯云万象优图返回失败了:{}", e.getMessage());
            return headImgUrl;
        }
    }

    @Override
    public ServiceResponse<String> getStaffQrcode(String clerkCode, String storeId) {
        ServiceResponse<String> resp = new ServiceResponse<>();
        List<String> clerkCodes = new ArrayList<>();
        clerkCodes.add(clerkCode);
        List<ClerkDTO> list = clerkService.listClerk(storeId, clerkCodes, true);
        if (CollectionUtils.isEmpty(list)) {
            logger.info("成员不存在：{}", clerkCode);
            return null;
        }
        ClerkDTO clerkDTO = list.get(0);

        StaffClerkRelationDTO relationDTO = staffClerkRelationService.getByClerkId(clerkDTO.getClerkId());
        if (relationDTO == null) {
            logger.info("成员没有关联:{}", clerkCode);
            return null;
        }
        String key = "qrcode-" + relationDTO.getStaffId();
        Object url = RedisUtil.getCache(key);
        if (null != url) {
            resp.setResult((String) url);
            return resp;
        }
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(relationDTO.getWxEnterpriseId());
        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(qwDTO.getWxEnterpriseId(), SecretTypeEnum.CUSTOMIZED_APP.getVal());
        if (null == secretSetting || secretSetting.getCheckFlag() == 0) {
            logger.info("没有配置secret:{}", qwDTO.getWxEnterpriseId());
            return null;
        }
        String staffId = relationDTO.getStaffId() ;
        TabHaobanStaff staff = this.staffMapper.selectByPrimaryKey(staffId) ;
        String wxUserId = staff.getWxUserId() ;
        if (qwDTO.needOpenUserIdDk()) {
            wxUserId = staff.getWxOpenUseId() ;
        }
        UserDTO user = qywxUserApiService.getSelfWorkWxUser(qwDTO.getDkCorpid(), secretSetting.getSecretVal(), wxUserId);
        if (user != null) {
            RedisUtil.setCache(key, user.getQr_code(), 2L, TimeUnit.DAYS);
            resp.setResult(user.getQr_code());
            return resp;
        }
        return resp;
    }

    @Override
    public List<String> listBindStaffId(String storeId) {
       return this.listBind(storeId, 1) ;
    }
    
    @Override
    public List<String> listBindClerkId(String storeId) {
        return this.listBind(storeId, 2) ;
    }
    
    private List<String> listBind(String storeId , int type) {
        List<String> userIdList = new ArrayList<String>();
        List<String> storeIds = new ArrayList<String>();
        storeIds.add(storeId);
        List<String> clerkList = clerkService.getclerkListByStoreIds(storeIds);
        List<StaffClerkRelationDTO> staffRelationList = staffClerkRelationService.listByClerkIds(clerkList);
        if (CollectionUtils.isEmpty(staffRelationList)) {
            return Collections.EMPTY_LIST;
        }
        if(type==1) {
            Map<String, StaffClerkRelationDTO> clerkIdMap = staffRelationList.stream().filter(s -> s.getClerkId() != null).collect(Collectors.toMap(StaffClerkRelationDTO::getClerkId, s -> s));
            Set<String> keySet = clerkIdMap.keySet();
            for (String clerkId : clerkList) {
                if (keySet.contains(clerkId)) {
                    userIdList.add(clerkIdMap.get(clerkId).getStaffId());
                }
            }
        }
        if(type==2) {
            userIdList = staffRelationList.stream().filter(s -> s.getClerkId() != null).map(dto->dto.getClerkId()).collect(Collectors.toList());
        }
        return userIdList;
    }
    

    @Override
    public List<StaffClerkRelationDTO> listBindRelationUserId(String storeId) {
        List<StaffClerkRelationDTO> bindList = new ArrayList<StaffClerkRelationDTO>();

        List<String> storeIds = new ArrayList<String>();
        storeIds.add(storeId);
        List<String> clerkList = clerkService.getclerkListByStoreIds(storeIds);
        List<StaffClerkRelationDTO> staffRelationList = staffClerkRelationService.listByClerkIds(clerkList);
        Map<String, StaffClerkRelationDTO> clerkIdMap = staffRelationList.stream().filter(s -> s.getClerkId() != null).collect(Collectors.toMap(StaffClerkRelationDTO::getClerkId, s -> s));
        Set<String> keySet = clerkIdMap.keySet();
        for (String clerkId : clerkList) {
            if (keySet.contains(clerkId)) {
                bindList.add(clerkIdMap.get(clerkId));
            }
        }
        return bindList;
    }

    @Override
    public boolean activeStaff(String staffId) {
        TabHaobanStaff staff = new TabHaobanStaff();
        staff.setStaffId(staffId);
        staff.setActiveFlag(1);
        staffService.updateByPrimaryKey(staff);
        return true;
    }

    @Override
    public StaffPrivacyUseLogDTO getStaffPrivacyByStaffId(String staffId) {
        return EntityUtil.changeEntity(StaffPrivacyUseLogDTO.class, staffPrivacyUseLogService.getByStaffId(staffId));
    }

    @Override
    public StaffPrivacyUseLogDTO getStaffPrivacyByUserId(String userId) {
        return EntityUtil.changeEntity(StaffPrivacyUseLogDTO.class, staffPrivacyUseLogService.getByUserId(userId));
    }

    @Override
    public Page<StaffDTO> listUserIdByWxEnterpriseId(String wxEnterpriseId, Integer pageNum, Integer pageSize) {
        PageHelper.startPage(pageNum, pageSize);
        List<TabHaobanStaff> tabHaobanStaffs = staffMapper.listByWxEnterpriseId(wxEnterpriseId);
        return PageUtil.changePageHelperToCurrentPage(new PageInfo<>(tabHaobanStaffs), StaffDTO.class);
    }

    @Override
    public List<StaffDTO> listAllStaffByWxEnterpriseId(String wxEnterpriseId) {
        List<TabHaobanStaff> tabHaobanStaffs = staffMapper.listByWxEnterpriseId(wxEnterpriseId);
        return EntityUtil.changeEntityListNew(StaffDTO.class, tabHaobanStaffs);
    }

    @Override
    public List<StaffDTO> listByOpenUserIdsAndWxEnterpriseId(List<String> openUserIds, String wxEnterpriseId) {
        List<StaffDTO> list = staffService.listByOpenUserIdsAndWxEnterpriseId(openUserIds, wxEnterpriseId);
        if (CollectionUtils.isEmpty(list)) {
            return Collections.EMPTY_LIST;
        }
        this.addDepartInfo(list);
        return list;
    }


    private void addDepartInfo(List<StaffDTO> list) {
        List<String> staffIdList = list.stream().map(dto -> dto.getStaffId()).collect(Collectors.toList());
        List<TabHaobanStaffDepartmentRelated> deplist = staffDepartmentRelatedMapper.listStaffDepartmentByStaffIds(staffIdList);
        if (CollectionUtil.isNotEmpty(list)) {
            Map<String, List<TabHaobanStaffDepartmentRelated>> map = deplist.stream().collect(Collectors.groupingBy(TabHaobanStaffDepartmentRelated::getStaffId));
            List<String> depIdList = deplist.stream().map(dto -> dto.getDepartmentId()).collect(Collectors.toList());
            List<DepartmentDTO> departmentList = this.departmentService.listByIds(depIdList);
            Map<String, DepartmentDTO> depMap = departmentList.stream().collect(Collectors.toMap(DepartmentDTO::getDepartmentId, dto -> dto, (k1, k2) -> k1));
            for (StaffDTO dto : list) {
                String staffId = dto.getStaffId();
                List<TabHaobanStaffDepartmentRelated> relateList = map.get(staffId);
                if (CollectionUtils.isNotEmpty(relateList)) {
                    List<DepartmentDTO> staffDepList = new ArrayList<>();
                    for (TabHaobanStaffDepartmentRelated item : relateList) {
                        if (null != depMap.get(item.getDepartmentId())) {
                            staffDepList.add(depMap.get(item.getDepartmentId()));
                        }
                    }
                    dto.setDepartmentList(staffDepList);
                }
            }
        }
    }

    @Override
    public int updateOpenUserIdsByUserId(String wxEnterpriseId, String wxUserId, String wxOpenUseId) {
        return staffService.updateOpenUserIdsByUserId(wxEnterpriseId, wxUserId, wxOpenUseId);
    }

    @Override
    public int updateOpenIdByStaffId(String staffId, String openId) {
        return staffMapper.updateOpenIdByStaffId(staffId, openId);
    }

    @Override
    public int updateQrCodeByStaffId(String staffId, String qrCode) {
        return staffMapper.updateQrCodeByStaffId(staffId, qrCode);
    }

    @Override
    public StaffQrCodeDTO getQrCodeByClerkId(String clerkId) {
        StaffClerkRelationDTO staffClerkRelationDTO = staffClerkRelationService.getByClerkId(clerkId);
        if (staffClerkRelationDTO == null) {
            return null;
        }
        String staffId = staffClerkRelationDTO.getStaffId();
        String wxEnterpriseId = staffClerkRelationDTO.getWxEnterpriseId();

        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CUSTOMIZED_APP.getVal());
        if (null == secretSetting || secretSetting.getCheckFlag() == 0) {
            logger.info("没有配置secret：wxEnterpriseId:{}", wxEnterpriseId);
            return null;
        }
        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(wxEnterpriseId);
        if (qwDTO == null) {
            logger.info("企业不存在：wxEnterpriseId:{}", wxEnterpriseId);
            return null;
        }
        TabHaobanStaff staff = staffService.selectById(staffId);
        if (staff == null) {
            logger.info("员工不存在：staffId:{}", staffId);
            return null;
        }
        StaffQrCodeDTO staffQrCodeDTO = new StaffQrCodeDTO();
        staffQrCodeDTO.setStaffId(staffId);
        staffQrCodeDTO.setHeadImg(staff.getHeadImg());
        staffQrCodeDTO.setStaffName(staff.getStaffName());
        staffQrCodeDTO.setNickName(staff.getNickName());
        staffQrCodeDTO.setPhoneNumber(staff.getPhoneNumber());
        staffQrCodeDTO.setClerkCode(staffClerkRelationDTO.getClerkCode());

        String qrCode = staff.getQrCode();
        staffQrCodeDTO.setQrCode(qrCode);
        if (StringUtils.isNotBlank(qrCode)) {
            return staffQrCodeDTO;
        }

        //获取微信信息
        String wxUserId = staff.getWxUserId();
        if (qwDTO.needOpenUserIdDk()) {
            wxUserId = staff.getWxOpenUseId();
        }
        UserDTO user = qywxUserApiService.getSelfWorkWxUser(qwDTO.getDkCorpid(), secretSetting.getSecretVal(), wxUserId);
        if (null == user) {
            logger.info("企业微信用户不存在:wxEnterpriseId:{}:wxUserId:{}", wxEnterpriseId, wxUserId);
            return staffQrCodeDTO;
        }
        String qr_code = user.getQr_code();
        staffMapper.updateQrCodeByStaffId(staffId, qr_code);
        staffQrCodeDTO.setQrCode(qr_code);
        return staffQrCodeDTO;
    }

    @Override
    public List<String> getHaoBanStoreIdsRolesByClerkId(String clerkId, String wxEnterpriseId) {
        logger.info("查询导购权限，clerkId={},wxEnterpriseId={}", clerkId, wxEnterpriseId);
        if (StringUtils.isAnyBlank(clerkId, wxEnterpriseId)) {
            logger.info("参数为空clerkId={},wxEnterpriseId={}", clerkId, wxEnterpriseId);
            return Collections.emptyList();
        }
        String cacheKey = "hb:clerk:store:" + clerkId + wxEnterpriseId;
        Object cache = RedisUtil.getCache(cacheKey);
        if (cache != null) {
            List<String> storeList = (List<String>) cache;
            logger.info("从缓存中获取key={},store数量:{}", cacheKey, storeList.size());
            return storeList;
        }
        ClerkDTO clerkDTO = clerkService.getClerkByClerkId(clerkId);
        if (clerkDTO == null) {
            logger.info("导购不存在：clerkId:{},无门店", clerkId);
            return Collections.emptyList();
        }
        String enterpriseId = clerkDTO.getEnterpriseId();
        List<String> enterpriseIdStoreIds = storeRangeService.listStoreIdByWxEnterpriseId(wxEnterpriseId, enterpriseId);
        if (CollectionUtils.isEmpty(enterpriseIdStoreIds)) {
            logger.info("无好办门店,eid={}", enterpriseId);
            return Collections.emptyList();
        }
        logger.info("好办门店数量={}", enterpriseIdStoreIds.size());
        List<String> gicStoreIds = getStoreIdList(clerkDTO);
        if (CollectionUtils.isEmpty(gicStoreIds)) {
            logger.info("无gic门店为空");
            return Collections.emptyList();
        }
        if (gicStoreIds.contains("-1")) {
            logger.info("gic超管，clerkId:{}", clerkId);
            List<String> storeGroupIds = storeRangeService.listStoreGroupIdByWxEnterpriseId(wxEnterpriseId, enterpriseId);
            if (CollectionUtils.isEmpty(storeGroupIds)) {
                logger.info("好办门店分组id为空");
                return Collections.emptyList();
            }
            String[] array = storeGroupIds.toArray(new String[0]);
            List<StoreGroupDTO> storeGroupDTOS = storeGroupService.listStoreGroup(array, enterpriseId);
            List<String> parentGroupIds = storeGroupDTOS.stream().map(StoreGroupDTO::getParentGroupId).collect(Collectors.toList());
            if (CollectionUtils.isNotEmpty(parentGroupIds) && parentGroupIds.contains("0")) {
                logger.info("gic是超管，企微包含所有门店，clerkId:{}", clerkId);
                enterpriseIdStoreIds = Collections.singletonList("-1");
            }
            RedisUtil.setCache(cacheKey, enterpriseIdStoreIds, 10L, TimeUnit.MINUTES);
            return enterpriseIdStoreIds;
        }
        logger.info("gic门店数量={}", gicStoreIds.size());
        //取交集
        List<String> storeList = RolesListUtils.mergeList(enterpriseIdStoreIds, gicStoreIds);
        logger.info("clerkId={},门店交集数量={}", clerkId, storeList.size());
        RedisUtil.setCache(cacheKey, storeList, 10L, TimeUnit.MINUTES);
        return storeList;
    }

    @Override
    public List<String> getHaoBanStoreRolesByStoreWidgetId(String storeWidgetId, String wxEnterpriseId, String enterpriseId) {
        return getStoreWidgetIdStoreIds(storeWidgetId, enterpriseId);
    }

    @Override
    public boolean isFlagByStoreIdAndEnterpriseId(String storeId, String enterpriseId, String wxEnterpriseId) {
        return storeRangeService.isFlagByStoreId(storeId, wxEnterpriseId, enterpriseId);
    }

    @Override
    public boolean isSuperAdmin(String clerkId) {
        ClerkDTO clerkDTO = clerkService.getClerkByClerkId(clerkId);
        if (clerkDTO == null) {
            return false;
        }
        Integer superAdmin = clerkDTO.getSuperAdmin();
        return superAdmin != null && superAdmin == 1;
    }

    @Override
    public List<String> getHaoBanStoreRolesByEnterpriseId(String enterpriseId, String wxEnterpriseId) {
        return storeRangeService.listStoreIdByWxEnterpriseId(wxEnterpriseId, enterpriseId);
    }

    @Override
    public StoreRoleDTO getCountHaoBanStoreIdsByClerkId(String clerkId, String wxEnterpriseId) {
        StoreRoleDTO storeRoleDTO = new StoreRoleDTO();
        ClerkDTO clerkDTO = clerkService.getClerkByClerkIdNoStatus(clerkId);
        if (clerkDTO == null) {
            storeRoleDTO.setStoreCount(0);
            return storeRoleDTO;
        }
        Integer clerkType = clerkDTO.getClerkType();
        if (clerkType != null && clerkType != 2) {
            storeRoleDTO.setStoreCount(1);
            storeRoleDTO.setStoreId(clerkDTO.getStoreId());
            return storeRoleDTO;
        }
        List<String> storeIds = getHaoBanStoreIdsRolesByClerkId(clerkId, wxEnterpriseId);
        if (CollectionUtils.isEmpty(storeIds)) {
            storeRoleDTO.setStoreCount(0);
            return storeRoleDTO;
        }
        if (storeIds.contains("-1")) {
            logger.info("该导购为所有门店,clerkId={}",clerkId);
            String storeWidgetId = this.powerService.getStoreWidgetId(new Date(), clerkId);
            int storeCount = 0 ;
            String storeId = null ;
            if(null != storeWidgetId) {
                Page<Object> pageParam = new Page<Object>();
                pageParam.setCurrentPage(1);
                pageParam.setPageSize(1);
                Page<StoreDTO> page = storeWidgetService.getStoreWidgetStore(storeWidgetId, null, clerkDTO.getEnterpriseId(), pageParam, null,null);
                storeId = page.getResult().get(0).getStoreId();
                storeCount = page.getTotalCount();
                storeRoleDTO.setStoreId(storeId);
                storeRoleDTO.setStoreCount(storeCount);
            }
            return storeRoleDTO;
        }
        int size = storeIds.size();
        storeRoleDTO.setStoreCount(size);
        if (size >= 1) {
            storeRoleDTO.setStoreId(storeIds.get(0));
        }
        return storeRoleDTO;
    }

    /**
     * 门店筛选器id企业端获取gic门店id列表
     */
    private List<String> getStoreIdList(ClerkDTO clerkDTO) {
        String clerkId = clerkDTO.getClerkId();
        Integer superAdmin = clerkDTO.getSuperAdmin();
        if (superAdmin != null && superAdmin == 1) {
            logger.info("gic超管，clerkId：{}", clerkId);
            return Collections.singletonList("-1");
        }
        String enterpriseId = clerkDTO.getEnterpriseId();
        EnterpriseSettingDTO enterpriseSetting = enterpriseService.getEnterpriseSettingByEnterpriseId(enterpriseId);
        if (enterpriseSetting.getEnableAccessControl() != null && enterpriseSetting.getEnableAccessControl() == 1) {
            String storeWidgetId = this.powerService.getStoreWidgetId(new Date(), clerkId);
            if (StringUtils.isBlank(storeWidgetId)) {
                logger.info("导购无门店权限,门店组件id is null");
                return Collections.emptyList();
            }
            StoreWidgetDTO storeWidgetDTO = this.storeWidgetService.getStoreWidgetBykey(storeWidgetId);
            if (storeWidgetDTO == null) {
                logger.info("导购门店权限查不到,storeWidgetId={}",storeWidgetId);
                return Collections.emptyList();
            }
            Integer selectType = storeWidgetDTO.getSelectType();
            if (selectType != null && selectType == 0) {
                logger.info("gic超管所有门店,clerkId：{}", clerkId);
                return Collections.singletonList("-1");
            }
            return getStoreWidgetIdStoreIds(storeWidgetId, enterpriseId);
        } else {
            logger.info("无开启权限 ,所有门店,clerkId={}", clerkId);
            return Collections.singletonList("-1");
        }
    }

    /**
     * 获取门店筛选器门店ids
     */
    private List<String> getStoreWidgetIdStoreIds(String storeWidgetId, String enterpriseId) {
        // 门店id列表
        List<String> storeIdList = storeWidgetService.getStoreWidgetStore(storeWidgetId, enterpriseId, null, null, 0);
        if (CollectionUtils.isEmpty(storeIdList)) {
            return Collections.emptyList();
        }
        logger.info("门店筛选器查询结果数量:{}", storeIdList.size());
        return storeIdList;
    }

    @Override
    public boolean isManager(String clerkId) {
        logger.info("查询是否店长：{}", clerkId);
        ClerkDTO clerkDTO = clerkService.getClerkByClerkId(clerkId);
        if (clerkDTO != null) {
            Integer clerkType = clerkDTO.getClerkType();
            if (clerkType == 1 || clerkType == 2) {
                return true;
            }
        }
        return false;
    }
    
    @Override
    public com.gic.api.base.commons.ServiceResponse<Boolean> isEnterpriseManager(String clerkId) {
        ClerkDTO clerkDTO = clerkService.getClerkByClerkId(clerkId);
        if (clerkDTO != null) {
            Integer clerkType = clerkDTO.getClerkType();
            if (clerkType == 2) {
                return com.gic.api.base.commons.ServiceResponse.success(true);
            }
        }
        return com.gic.api.base.commons.ServiceResponse.success(false);
    }

    @Override
    public List<StaffDTO> listBindStoreIds(List<String> storeIds, String wxEnterpriseId) {
        return staffMapper.listBindStoreIds(storeIds,wxEnterpriseId);
    }
}
